package net.minecraft.src;

import java.util.Iterator;
import java.util.List;

public class EntityDummy extends Entity
{
    private int livecount;
    private final int maxlivecount = 16;
    private int entityColor;
    public Entity entityOwner;

    public EntityDummy(World world, int i, Entity entity)
    {
        super(world);
        livecount = 16;
        entityColor = i;
        entityOwner = entity;
    }

    protected void entityInit()
    {
    }

    protected void readEntityFromNBT(NBTTagCompound nbttagcompound)
    {
    }

    protected void writeEntityToNBT(NBTTagCompound nbttagcompound)
    {
    }

    public void onUpdate()
    {
        super.onUpdate();
        if (--livecount < 0)
        {
            setEntityDead();
        }
    }

    public float getAlpha(float f)
    {
        if (livecount >= 0)
        {
            return (f * (float)livecount) / 16F;
        }
        else
        {
            return 0.0F;
        }
    }

    public int getColor()
    {
        return entityColor;
    }

    public boolean setOwnerdEntityDead(Entity entity)
    {
        if (entityOwner == entity)
        {
            setEntityDead();
            return true;
        }
        else
        {
            return false;
        }
    }

    public static void clearDummyEntity(World world, Entity entity)
    {
        List list = world.getLoadedEntityList();
        Iterator iterator = list.iterator();
        do
        {
            if (!iterator.hasNext())
            {
                break;
            }
            Entity entity1 = (Entity)iterator.next();
            if (entity1 instanceof EntityDummy)
            {
                ((EntityDummy)entity1).setOwnerdEntityDead(entity);
            }
        }
        while (true);
    }
}
