package net.minecraft.src;

public class EntityLittleMaidAvatar extends EntityPlayer
{
    public EntityLittleMaid avatar;
    public boolean isItemTrigger;
    public boolean isItemReload;
    private boolean isItemPreReload;

    public EntityLittleMaidAvatar(World world, EntityLittleMaid entitylittlemaid)
    {
        super(world);
        isDead = true;
        avatar = entitylittlemaid;
        inventory = entitylittlemaid.maidInventory;
        height = entitylittlemaid.height;
        width = entitylittlemaid.width;
        health = entitylittlemaid.health;
        activePotionsMap = entitylittlemaid.activePotionsMap;
        isItemTrigger = false;
        isItemReload = false;
        isItemPreReload = false;
    }

    public float getEyeHeight()
    {
        return avatar.getEyeHeight();
    }

    protected String getLivingSound()
    {
        return null;
    }

    protected String getHurtSound()
    {
        return null;
    }

    protected String getDeathSound()
    {
        return null;
    }

    public void func_6420_o()
    {
    }

    public void onUpdate()
    {
        if (isUsingItem())
        {
            ItemStack itemstack = inventory.getCurrentItem();
            if (itemstack != getItemInUse())
            {
                clearItemInUse();
            }
            else
            {
                int i = func_35205_Y();
                if (i <= 25 && i % 4 == 0)
                {
                    func_35201_a(itemstack, 5);
                }
                i--;
                super.clearItemInUse();
                setItemInUse(itemstack, i);
                if (i == 0 && !worldObj.isRemote)
                {
                    func_35208_ae();
                    isItemPreReload = true;
                }
            }
        }
    }

    public void onKillEntity(EntityLiving entityliving)
    {
    }

    public void clearItemInUse()
    {
        super.clearItemInUse();
        isItemTrigger = false;
        isItemReload = isItemPreReload = false;
    }

    public void stopUsingItem()
    {
        super.stopUsingItem();
    }

    public void setItemInUse(ItemStack itemstack, int i)
    {
        super.setItemInUse(itemstack, i);
        isItemTrigger = true;
        isItemReload = isItemPreReload;
    }

    public boolean isUsingItemLittleMaid()
    {
        return super.isUsingItem() | isItemTrigger;
    }

    public void getValue()
    {
        posX = avatar.posX;
        posY = avatar.posY;
        posZ = avatar.posZ;
        prevPosX = avatar.prevPosX;
        prevPosY = avatar.prevPosY;
        prevPosZ = avatar.prevPosZ;
        rotationPitch = avatar.rotationPitch;
        rotationYaw = avatar.rotationYaw;
        prevRotationPitch = avatar.prevRotationPitch;
        prevRotationYaw = avatar.prevRotationYaw;
        yOffset = avatar.yOffset;
        renderYawOffset = avatar.renderYawOffset;
        prevRenderYawOffset = avatar.prevRenderYawOffset;
    }

    public void getValueVector(double d, double d1, double d2, double d3)
    {
        double d4 = MathHelper.sqrt_double(d3);
        double d5 = d / d4;
        double d6 = d1 / d4;
        double d7 = d2 / d4;
        posX = avatar.posX + d5;
        posY = avatar.posY + d6;
        posZ = avatar.posZ + d7;
        prevPosX = avatar.prevPosX + d5;
        prevPosY = avatar.prevPosY + d6;
        prevPosZ = avatar.prevPosZ + d7;
        rotationPitch = avatar.rotationPitch;
        rotationYaw = avatar.rotationYaw;
        prevRotationPitch = avatar.prevRotationPitch;
        prevRotationYaw = avatar.prevRotationYaw;
        yOffset = avatar.yOffset;
        renderYawOffset = avatar.renderYawOffset;
        prevRenderYawOffset = avatar.prevRenderYawOffset;
        motionX = avatar.motionX;
        motionY = avatar.motionY;
        motionZ = avatar.motionZ;
        isSwinging = avatar.isSwinging;
    }

    public void setValue()
    {
        avatar.posX = posX;
        avatar.posY = posY;
        avatar.posZ = posZ;
        avatar.prevPosX = prevPosX;
        avatar.prevPosY = prevPosY;
        avatar.prevPosZ = prevPosZ;
        avatar.rotationPitch = rotationPitch;
        avatar.rotationYaw = rotationYaw;
        avatar.prevRotationPitch = prevRotationPitch;
        avatar.prevRotationYaw = prevRotationYaw;
        avatar.yOffset = yOffset;
        avatar.renderYawOffset = renderYawOffset;
        avatar.prevRenderYawOffset = prevRenderYawOffset;
    }

    public void setValueRotation()
    {
        avatar.rotationPitch = rotationPitch;
        avatar.rotationYaw = rotationYaw;
        avatar.prevRotationPitch = prevRotationPitch;
        avatar.prevRotationYaw = prevRotationYaw;
        avatar.renderYawOffset = renderYawOffset;
        avatar.prevRenderYawOffset = prevRenderYawOffset;
        avatar.motionX = motionX;
        avatar.motionY = motionY;
        avatar.motionZ = motionZ;
        avatar.isSwinging = isSwinging;
    }
}
