package net.minecraft.src;

import java.io.File;
import java.io.PrintStream;
import java.lang.reflect.Field;
import java.util.LinkedList;
import java.util.Map;
import net.minecraft.client.Minecraft;

public class mod_littleMaidMob extends BaseModMp
{
    public static Minecraft mcGame;
    public static Achievement ac_Contract;
    public static int spawnWeight = 5;
    public static int spawnLimit = 50;
    public static int minGroupSize = 1;
    public static int maxGroupSize = 3;
    public static boolean trampleCrops = false;
    public static float LivingVoiceRate = 1.0F;
    public static boolean VoiceDistortion = true;
    public static String defaultTexture = "";
    public static boolean DebugMessage = false;
    public static boolean Dominant = false;
    public static boolean AlphaBlend = true;
    public static int AchievementID = 0x36330;
    public static boolean isDebugView = false;
    public static int litttleMaidID = 109;
    public static int dummyID = 83;
    public static int avatarID = 84;
    public static int inventoryGUI = 66;
    public static int packetCloseGUI = 1;
    public static int packetPlaySound = 2;
    public static int packetIFFTrigger = 3;
    public static int packetMaidName = 4;

    public mod_littleMaidMob()
    {
    }

    public static void Debug(String s)
    {
        if (DebugMessage)
        {
            System.out.println((new StringBuilder()).append("littleMaidMob-").append(s).toString());
        }
    }

    public String getVersion()
    {
        return "SMP_0.2.0";
    }

    public void load()
    {
        ModLoader.RegisterEntityID(net.minecraft.src.EntityLittleMaid.class, "LittleMaid", litttleMaidID);
        ModLoaderMp.RegisterNetClientHandlerEntity(net.minecraft.src.EntityDummy.class, dummyID);
        ModLoaderMp.RegisterNetClientHandlerEntity(net.minecraft.src.EntityLittleMaidAvatar.class, avatarID);
        ModLoaderMp.RegisterGUI(this, inventoryGUI);
        mcGame = ModLoader.getMinecraftInstance();
        Debug("SoundDir:".concat(Minecraft.getAppDir("minecraft/resources/mod/sound").toString()));
        SoundLittleMaid.loadDefaultSoundPack();
        SoundLittleMaid.loadSoundPack();
        if (AchievementID != 0)
        {
            ac_Contract = (new Achievement(AchievementID, "littleMaid", 1, -4, Item.cake, AchievementList.bakeCake)).registerAchievement();
            ModLoader.AddAchievementDesc(ac_Contract, "Enlightenment!", "Capture the LittleMaid!");
        }
    }

    public void AddRenderer(Map map)
    {
        map.put(net.minecraft.src.EntityLittleMaid.class, new RenderLittleMaid(new ModelLittleMaid(), 0.3F));
        if (isDebugView)
        {
            map.put(net.minecraft.src.EntityDummy.class, new RenderDummy());
        }
    }

    public void ModsLoaded()
    {
        if (Dominant)
        {
            try
            {
                Field afield[] = (net.minecraft.src.BiomeGenBase.class).getDeclaredFields();
                LinkedList linkedlist = new LinkedList();
                for (int i = 0; i < afield.length; i++)
                {
                    Class class1 = afield[i].getType();
                    if ((afield[i].getModifiers() & 8) != 0 && class1.isAssignableFrom(net.minecraft.src.BiomeGenBase.class))
                    {
                        BiomeGenBase biomegenbase = (BiomeGenBase)afield[i].get(null);
                        linkedlist.add(biomegenbase);
                    }
                }

                BiomeGenBase abiomegenbase[] = (BiomeGenBase[])linkedlist.toArray(new BiomeGenBase[0]);
                ModLoader.AddSpawn(net.minecraft.src.EntityLittleMaid.class, 1, minGroupSize, maxGroupSize, EnumCreatureType.creature, abiomegenbase);
            }
            catch (Exception exception)
            {
                Debug("Dominate Exception.");
            }
        }
        else if (spawnWeight > 0)
        {
            ModLoader.AddSpawn(net.minecraft.src.EntityLittleMaid.class, spawnWeight, minGroupSize, maxGroupSize, EnumCreatureType.creature);
        }
        TextureLittleMaid.getArmorPrefix();
        TextureLittleMaid.getModFile();
        TextureLittleMaid.getTextures();
        GuiLittleMaidIFF.loadIFF();
        GuiLittleMaidTriggerSelect.initTriggerItem();
        String as[] = {GuiLittleMaidTriggerSelect.SwordIndex,GuiLittleMaidTriggerSelect.AxeIndex,GuiLittleMaidTriggerSelect.BowIndex,GuiLittleMaidIFF.tmpIFFMap};
        SendPacketLittleMaidData(packetIFFTrigger,as,null,null);
    }

    public GuiScreen HandleGUI(int guiId)
    {
        EntityPlayerSP entityplayersp = ModLoader.getMinecraftInstance().thePlayer;
        if(entityplayersp == null)
        {
            return null;
        }
        if(guiId == inventoryGUI){
            int i = 0;
            EntityLittleMaid entitylittlemaid = null;
            do
            {
                if(i >= mcGame.theWorld.loadedEntityList.size())
                {
                    break;
                }
                Entity entity = (Entity)mcGame.theWorld.loadedEntityList.get(i);
                if(entity instanceof EntityLittleMaid)
                {
                    entitylittlemaid = (EntityLittleMaid)entity;
                    if(entitylittlemaid.openGUIFlag)
                    {
                        entitylittlemaid.openGUIFlag = false;
                        return new GuiLittleMaidInventory(entitylittlemaid,entityplayersp.inventory,entitylittlemaid.maidInventory);
                    }
                }
                i++;
            } while(true);
            entitylittlemaid.openGUIFlag = false;
        }
        return null;
    }

    public void HandlePacket(Packet230ModLoader packet)
    {
        if(packet.packetType == packetPlaySound)
        {
            int i = 0;
            EntityLittleMaid entitylittlemaid = null;
            EntityPlayerSP entityplayersp = ModLoader.getMinecraftInstance().thePlayer;
            do
            {
                if(i >= mcGame.theWorld.loadedEntityList.size())
                {
                    break;
                }
                Entity entity = (Entity)mcGame.theWorld.loadedEntityList.get(i);
                if(entity instanceof EntityLittleMaid)
                {
                    entitylittlemaid = (EntityLittleMaid)entity;
                    if(packet.dataInt[0] == entitylittlemaid.getMaidId())
                    {
                        for(EnumSoundLittleMaid obj : EnumSoundLittleMaid.values()) {
                            if (obj.index == packet.dataInt[1])
                            {
                                entitylittlemaid.playSound(obj);
                                break;
                            }
                        }
                    return;
                    }
                }
                i++;
            } while(true);
        }
        else if (packet.packetType == packetIFFTrigger)
        {
            String as[] = {GuiLittleMaidTriggerSelect.SwordIndex,GuiLittleMaidTriggerSelect.AxeIndex,GuiLittleMaidTriggerSelect.BowIndex,GuiLittleMaidIFF.tmpIFFMap};
            SendPacketLittleMaidData(packetIFFTrigger,as,null,null);
        }
    }

    public static void SendPacketLittleMaidData(int packetType,String as[],int ai[],float af[])
    {
        if(ModLoaderMp.GetModInstance(mod_littleMaidMob.class) != null)
        {
            Packet230ModLoader packet = new Packet230ModLoader();
            packet.packetType = packetType;
            if (packetType == packetCloseGUI)
            {
                packet.dataString = as;
                packet.dataInt = ai;
            }
            else if (packetType == packetIFFTrigger)
            {
                packet.dataString = as;
            }
            else if (packetType == packetMaidName)
            {
                packet.dataString = as;
                packet.dataInt = ai;
            }
            ModLoaderMp.SendPacket( ModLoaderMp.GetModInstance(mod_littleMaidMob.class), packet);
        }
    }

}
